namespace PkmnLib.Dynamic.Events;

/// <summary>
/// An event is something that happens during a battle. This can be used by front-end code to
/// display information about the battle to the user. This is the only way for the front-end to
/// know what is happening in the battle.
/// </summary>
public interface IEventData
{
    /// <summary>
    /// The batch ID indicated which batch of events this belong to. Events with the same batch id
    /// should be displayed together.
    /// </summary>
    public EventBatchId BatchId { get; init; }
}